package com;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.WebDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class HelloWorldController {
	
	 
	@RequestMapping("/helloDue")
	public String hello(Model model) {

		model.addAttribute("msg", "CIAO");

		return "helloworld";
	
	}

	@RequestMapping("/hello")
	public String hello(@RequestParam(value = "name", required = false, defaultValue = "Hello World") String name,
			Model model) {

		model.addAttribute("msg", name);

		return "helloworld";
	
	}

	
	
	
	@RequestMapping("/student")
	public String student(Model model) {

		model.addAttribute("studentForm", new Student());

		return "student";

	}
	
	
	
	
	// si puo fare cosi ma  molto piu semplice l altro modo
//	@RequestMapping(value = "/student", method = RequestMethod.GET)
//	public ModelAndView student() {
//		return new ModelAndView("student", "command", new Student());// (nomevista, nomedel model che puo essere richiamato nella vista, oggetto della vista)
//	}

	@RequestMapping(value = "/addStudent", method = RequestMethod.POST)
	public String addStudent(@ModelAttribute("studentForm") Student student,//(nome attirbuto )

			ModelMap model) {
		model.addAttribute("name", student.getName());
		model.addAttribute("age", student.getAge());
		model.addAttribute("id", student.getId());

		return "result";
	}
	
		
	// serve per dare un formato alle data in ingresso
	 @InitBinder
	    public void initBinder(WebDataBinder binder){
	        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
	        sdf.setLenient(true);
	        binder.registerCustomEditor(Date.class, new CustomDateEditor(sdf, true));
	    }
	 


}